function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["className", "style"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * 可拖拽table
 * @author 施阳 2021-4-14
 */
import React, { useState, useEffect, cloneElement } from 'react';
import { SortableContainer, SortableElement, SortableHandle } from 'react-sortable-hoc';
import { Table } from 'antd';
import { useConfig } from "../_util/hooks";
import IconFont from "../iconfont";
import "./index.less";
var DragHandle = SortableHandle(function () {
  return /*#__PURE__*/React.createElement(IconFont, {
    type: "icon-ehr-ui-drag",
    style: {
      cursor: 'move',
      color: '#999'
    }
  });
});
var SortableItem = SortableElement(function (props) {
  return /*#__PURE__*/React.createElement("tr", props);
});
var Container = SortableContainer(function (props) {
  return /*#__PURE__*/React.createElement("tbody", props);
});

// 处理拖拽Table参数
var DEFAULT_VALUE = [];
var useDragParams = function useDragParams(props) {
  var _props$columns = props.columns,
    columns = _props$columns === void 0 ? [] : _props$columns,
    _props$dataSource = props.dataSource,
    originData = _props$dataSource === void 0 ? DEFAULT_VALUE : _props$dataSource,
    _props$rowKey = props.rowKey,
    rowKey = _props$rowKey === void 0 ? 'id' : _props$rowKey,
    onSort = props.onSort,
    components = props.components;
  if (components) {
    console.error('useDragTable函数会覆盖传入Table组件的components属性哦，若原组件必须设置components属性请避免结合useDragTable函数使用');
  }
  var _useState = useState(_toConsumableArray(originData)),
    _useState2 = _slicedToArray(_useState, 2),
    dataSource = _useState2[0],
    setDataSource = _useState2[1];
  useEffect(function () {
    setDataSource(_toConsumableArray(originData));
  }, [originData]);
  var onSortEnd = function onSortEnd(_ref) {
    var oldIndex = _ref.oldIndex,
      newIndex = _ref.newIndex;
    if (oldIndex !== newIndex) {
      var list = _toConsumableArray(dataSource);
      var _list$splice = list.splice(oldIndex, 1),
        _list$splice2 = _slicedToArray(_list$splice, 1),
        item = _list$splice2[0]; // 截取移动项
      list.splice(newIndex, 0, item); // 将移动项插入到新位置
      setDataSource(list);
      onSort && onSort(oldIndex, newIndex, list);
    }
  };
  var DraggableContainer = function DraggableContainer(props) {
    return /*#__PURE__*/React.createElement(Container, _extends({
      useDragHandle: true,
      helperClass: "row-dragging",
      onSortEnd: onSortEnd
    }, props));
  };
  var DraggableBodyRow = function DraggableBodyRow(_ref2) {
    var className = _ref2.className,
      style = _ref2.style,
      restProps = _objectWithoutProperties(_ref2, _excluded);
    var index = dataSource.findIndex(function (x) {
      return x[typeof rowKey === 'string' || typeof rowKey === 'number' ? rowKey : rowKey(x)] === restProps['data-row-key'];
    });
    return /*#__PURE__*/React.createElement(SortableItem, _extends({
      index: index
    }, restProps));
  };
  var newColumns = [{
    title: '',
    dataIndex: 'sort',
    width: 30,
    className: 'drag-visible',
    render: function render() {
      return /*#__PURE__*/React.createElement(DragHandle, null);
    }
  }].concat(_toConsumableArray(columns));
  return {
    rowKey: rowKey,
    dataSource: dataSource,
    columns: newColumns,
    components: {
      body: {
        wrapper: DraggableContainer,
        row: DraggableBodyRow
      }
    }
  };
};
var useDragTable = function useDragTable(element, option) {
  var extraParams = useDragParams(_objectSpread(_objectSpread({}, element.props), option));
  return useConfig( /*#__PURE__*/cloneElement(element, _objectSpread(_objectSpread({}, element.props), extraParams)));
};
var DragTable = function DragTable(props) {
  var extraParams = useDragParams(props);
  return useConfig( /*#__PURE__*/React.createElement(Table, _extends({}, props, extraParams)));
};
DragTable.useDragTable = useDragTable;
export default DragTable;